#lang racket/base
(require syntax/parse
         "class-loc.rkt"
         "inherit-loc.rkt"
         (for-template "method-macro.rkt"
                       "class-macro.rkt"
                       "typed-class-macro.rkt"
                       "op-macro.rkt"))

;; The tests of "inherit-loc.rkt" really belong here, too.

(provide parse)

(define (parse stx)
  (syntax-parse stx
    #:literals {arg this +-form *-form new get send super}
    [n:number (numI (syntax-e #'n) stx)]
    [arg (argI stx)]
    [this (thisI stx)]
    [{+-form l r} (plusI (parse #'l) (parse #'r) stx)]
    [{*-form l r} (multI (parse #'l) (parse #'r) stx)]
    [{new cls:id arg-expr ...}
     (newI (syntax-e #'cls)
           (map parse (syntax-e #'(arg-expr ...)))
           stx)]
    [{get obj-expr fld:id}
     (getI (parse #'obj-expr) (syntax-e #'fld) stx)]
    [{send obj-expr mthd:id arg-expr}
     (sendI (parse #'obj-expr) (syntax-e #'mthd) (parse #'arg-expr) stx)]
    [{super mthd:id arg-expr}
     (superI (syntax-e #'mthd) (parse #'arg-expr) stx)]))
