#lang racket/base
(require syntax/parse
         "class-loc.rkt"
         "inherit-loc.rkt"
         "typed-class-loc.rkt"
         "inherit-parse-loc.rkt"
         (for-template "class-macro.rkt"
                       "typed-class-macro.rkt"))

;; The tests of "typed-parse.rkt" really belong here, too.

(provide parse-t-class)

(define (parse-t-class stx)
  (syntax-parse stx
    #:literals (class extends)
    [{class name extends super-name {fld ...} mthd ...}
     (classT (syntax-e #'name)
             (syntax-e #'super-name)
             (map parse-t-field
                  (syntax->list #'(fld ...)))
             (map parse-t-method 
                  (syntax->list #'(mthd ...))))]))

(define (parse-t-field stx)
  (syntax-parse stx
    #:literals (:)
    [{fld:id : type}
     (fieldT (syntax-e #'fld) (parse-type #'type))]))

(define (parse-t-method stx)
  (syntax-parse stx
    #:literals (: ->)
    [{mthd:id : arg-type -> result-type expr}
     (methodT (syntax-e #'mthd)
              (parse-type #'arg-type)
              (parse-type #'result-type)
              (parse #'expr))]))

(define (parse-type stx)
  (syntax-parse stx
    #:literals (num)
    [num (numT)]
    [cls:id (objT (syntax-e #'cls))]))
